/**
 * Architektur & Implementierung von DBMS, Aufgabenblatt 7
 *
 * Bitmap Indexing, Query Processing and WAH Compression
 *
 * File        : PlainBitVector.cpp
 */

#include "PlainBitVector.h"

/***** Global bit operations on BitVectors *****/

/* AND operator with a temporary result */
PlainBitVector
operator& (const PlainBitVector& lhs, const PlainBitVector& rhs) 
{
    PlainBitVector result(lhs.size());
    
    for(uint32_t i=0; i<result.getNumWords(); i++) {
        result.data[i] = lhs.data[i] & rhs.data[i];
    }
    
    return result;
}

/* OR operator of two PlainBitVectors in a temporary result */
PlainBitVector 
operator| (const PlainBitVector& lhs, const PlainBitVector& rhs)
{
    PlainBitVector result(lhs.size());
    
    for(uint32_t i=0; i<result.getNumWords(); i++) {
        result.data[i] = lhs.data[i] | rhs.data[i];
    }
    
    return result;
}
